'use strict';

var postcss = require('postcss');
var shared = require('./shared-edae394d.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var postcss__default = /*#__PURE__*/_interopDefaultLegacy(postcss);

var postcss7 = postcss__default["default"].plugin('postcss-rpx-transform', function (options = {}) {
    const transUnits = ['rpx'];
    const opts = shared.getConfig(options);
    const pxRgx = shared.pxRegex(transUnits);
    const satisfyPropList = shared.createPropListMatcher(opts.propList);
    return function (css) {
        var _a;
        const pxReplace = shared.createPxReplace(
        // @ts-ignore
        opts.rootValue, opts.unitPrecision, opts.minValue, opts.transformUnit
        // @ts-ignore
        )((_a = css.source) === null || _a === void 0 ? void 0 : _a.input);
        if (css.nodes) {
            for (let i = 0; i < css.nodes.length; i++) {
                if (css.nodes[i].type === 'comment') {
                    if (css.nodes[i].text === 'postcss-rpx-transform disable') {
                        return;
                    }
                    else {
                        break;
                    }
                }
            }
        }
        css.walkDecls(function (decl, i) {
            // This should be the fastest test and will remove most declarations
            if (decl.value.indexOf('rpx') === -1)
                return;
            if (!satisfyPropList(decl.prop))
                return;
            if (shared.blacklistedSelector(opts.selectorBlackList, decl.parent.selector)) {
                return;
            }
            const value = decl.value.replace(pxRgx, pxReplace);
            // if rem unit already exists, do not add or replace
            // @ts-ignore
            if (shared.declarationExists(decl.parent, decl.prop, value))
                return;
            if (opts.replace) {
                decl.value = value;
            }
            else {
                decl.parent.insertAfter(i, decl.clone({ value }));
            }
        });
        if (opts.mediaQuery) {
            css.walkAtRules('media', function (rule) {
                if (rule.params.indexOf('rpx') === -1)
                    return;
                rule.params = rule.params.replace(pxRgx, pxReplace);
            });
        }
    };
});

module.exports = postcss7;
