import type { ChildNode, Container, Input } from 'postcss';
import type { UserDefinedOptions } from './type';
export declare const postcssPlugin = "postcss-rpx-transform";
export declare function getConfig(options: UserDefinedOptions): Omit<UserDefinedOptions, keyof UserDefinedOptions> & Omit<Required<UserDefinedOptions>, keyof UserDefinedOptions> & {
    rootValue: number | ((input: Input) => number);
    unitPrecision: number;
    selectorBlackList: (string | RegExp)[];
    propList: string[];
    replace: boolean;
    mediaQuery: boolean;
    minValue: number;
    exclude: string | RegExp | ((filePath: string) => boolean);
    transformUnit: "px" | "rem" | "vw";
};
export declare function toFixed(number: number, precision: number): number;
export declare function declarationExists(decls: Container<ChildNode>, prop: string, value: string): boolean;
export declare function blacklistedSelector(blacklist: (string | RegExp)[], selector?: string): boolean | undefined;
export declare function createPropListMatcher(propList: string[]): (prop: string) => boolean;
export declare function getTransformDivider(rootValue: number, transformUnit: 'px' | 'rem' | 'vw' | string): number;
export declare function createPxReplace(rootValue: number | ((input?: Input, m?: string, $1?: string) => number), unitPrecision: number, minPixelValue: number, transformUnit?: string): (input?: Input) => (m: string, $1: string) => string;
